<template>
  <div class="app-container list-farmer" style="padding: 0;">
    <el-table
      v-loading="listLoading"
      :key="tableKey"
      :data="list"
      fit
      list-farmer
      highlight-current-row
      style="width: 100%;">
      <el-table-column :label="$t('listFarmer.id')" align="center" width="90">
        <template slot-scope="scope">
          <span>{{ ((listQuery.page-1)*20) + scope.$index + 1}}</span>
        </template>
      </el-table-column>
      <el-table-column :label="$t('listFarmer.name')" style="width: calc(100% - 240);" align="left">
        <template slot-scope="scope">
          <span>{{ scope.row.farmer_name }}</span>
        </template>
      </el-table-column>
      <el-table-column width="150" align="left">
        <template slot-scope="scope">
          <a target="_blank" class="--link" :href="'/#/detail-farmer/' + scope.row.id">Lihat Detail</a>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :layout="'prev, pager, next'"
      :page.sync="listQuery.page"
      :limit.sync="listQuery.limit"
      :autoScroll="false"
      @pagination="getList" />
  </div>
</template>

<script>
import { getAllFarmer } from '@/api/farmer'
import waves from '@/directive/waves' // Waves directive
import Pagination from '@/components/Pagination' // Secondary package based on el-pagination

export default {
  name: 'ListFarmer',
  components: { Pagination },
  directives: { waves },
  props: ['params'],
  data() {
    return {
      tableKey: 0,
      list: null,
      total: 0,
      listLoading: true,
      listQuery: {
        page: 1,
        limit: 20
      }
    }
  },
  created() {
    this.getList()
  },
  watch: {
    params: function(newVal, oldVal) { // watch it
      this.listQuery.page = 1
      this.getList();
    }
  },
  methods: {
    getList() {
      this.listLoading = true
      this.listQuery = {...this.listQuery, ...this.params}
      getAllFarmer(this.listQuery).then(response => {
        this.list = response.data.data
        this.total = response.data.meta.total_data
        // Just to simulate the time of the request
        setTimeout(() => {
          this.listLoading = false
        }, 0.5 * 1000)
      })
    }
  }
}
</script>

<style rel="stylesheet/scss" lang="scss">
@import '@/styles/variables.scss';
@import '@/styles/mixin.scss';
.list-farmer {
  margin: 0 -32px;

  .el-table {
    &\-\-medium td, &\-\-medium th {
      padding: 0;
    }
    thead {
      th {
        background-color: $ritx-light-grey-2;

        .cell {
          color: $ritx-grey;
        }
      }
    }
    .cell {
      font-size: 16px;
      font-weight: bold;
      font-style: normal;
      font-stretch: normal;
      line-height: 3.75;
      letter-spacing: normal;
      color: $ritx-dark-grey;

      .\-\-link {
        color: $ritx-dark-orange;
        cursor: pointer;
      }
    }
  }

  .pagination-container {
    margin-top: 0;
    padding-right: 50px;
  }

  .el-pagination {
    display: flex;
    justify-content: flex-end;

    .btn-prev, .btn-next {
      background-color: white;
      margin: 0;
      height: 33px;
      color: #74bd40!important;
      border: solid 1px #086939!important;
    }
    .btn-prev:disabled, .btn-next:disabled {
      color: grey!important;
    }
    .btn-prev {
      border-top-left-radius: 4px;
      border-bottom-left-radius: 4px;
      border-right: none!important;
    }
    .btn-next {
      border-top-right-radius: 4px;
      border-bottom-right-radius: 4px;
    }
  }

  .el-pager {
    height: 33px;
    border: none;

    li {
      height: 33px;
      color: #086939!important;
      border: solid 1px #086939!important;
      border-right: none!important;
      background: white!important;
      margin: 0!important;
      border-radius: 0!important;

      :last-of-type {
        border-right: solid 1px #086939!important;
      }
    }

    li:not(.disabled).active {
      border: solid 1px #086939!important;
      background-color: #086939!important;
      color: white!important;
    }
  }
}
</style>
